from django import forms
from .models import Job


class JobForm(forms.ModelForm):

    def is_valid(self):
        super(JobForm, self).is_valid()
        if self.validate_query():
            return True
        else:
            return False

    def validate_query(self):
        query = self.cleaned_data['query']
        if query:
            block = [';', 'select', 'alter', 'drop', 'truncate', 'update']
            if any(ext in query for ext in block):
                raise forms.ValidationError('Bad query')
            else:
                return True
        else:
            return True

    class Meta:
        model = Job
        fields = ['name', 'query', 'scrap_old_news', 'spider', 'count', 'interval']
        exclude = ['job_uuid', 'create_time', 'end_time', 'status', 'schedule_job']